﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace WPF_XamDataChart_multiSeries
{
    public class UFStackSeries : ObservableCollection<UFChartDataSeries>
    {       
        Treatment currentTreatment;
        public Treatment CreateTreatment()
        {
            currentTreatment = new Treatment();
          
            for (int i = 0 ; i < 10; i++)
            {
                currentTreatment.Cycles.Add(new Cycle { CycleName = "Cycle" + i.ToString(), CycleIndex=i, UFVolume=10 + i });
            }

            return currentTreatment;
        }

        public UFStackSeries(Treatment currentTreatment)
        {
            string seriesName = "Series1";
            ObservableCollection<UFChartDataPoint> DataPoints = new ObservableCollection<UFChartDataPoint>();
           
            foreach (Cycle c in currentTreatment.Cycles)
            {
                //seriesName = "Cycle " + c.CycleIndex.ToString();               
                DataPoints.Add(new UFChartDataPoint()
                {
                    ColumnName= c.CycleName,
                    DataPointValue = c.UFVolume
                });
            }

            this.Add(new UFChartDataSeries()
            {
                SeriesName = seriesName,
                DataPoints = DataPoints
            });
           
            //string SeriesName;
            //ObservableCollection<UFChartDataPoint> DataPoints = new ObservableCollection<UFChartDataPoint>();
            //foreach (Cycle c in CurrentTreatment.Cycles)
            //{
            //    SeriesName = "Cycle " + c.CycleIndex.ToString();
            //    DataPoints = new ObservableCollection<UFChartDataPoint>();
            //    DataPoints.Add(new UFChartDataPoint()
            //    {
            //        DataPointValue = c.UFVolume
            //    });

            //    this.Add(new UFChartDataSeries()
            //    {
            //        SeriesName = SeriesName,
            //        DataPoints = DataPoints
            //    });
            //}
        }

        public UFStackSeries()
        {           
        }
    }

    /// 
    /// Data series for the UFChart
    /// 
    public class UFChartDataSeries
    {
        public string SeriesName { get; set; }

        public ObservableCollection<UFChartDataPoint> DataPoints { get; set; }
    }


    public class UFChartDataPoint
    {
        //private const string m_ColumnLabel = "Volume";
        //public string ColumnLabel
        //{
        //    get
        //    {
        //        return m_ColumnLabel;
        //    }
        //}

        public string ColumnName { get; set; }

        public double DataPointValue { get; set; }   
    }


    public class Treatment
    {
        Collection<Cycle> cycles = new Collection<Cycle>();

        public Treatment()
        {
            cycles = new Collection<Cycle>();
        }

        public Collection<Cycle> Cycles
        {
            get{ return cycles; }                        
        }       
    }

    public class Cycle
    {   
        public string CycleName { get; set; }       
        public int CycleIndex{ get; set; }
        public double UFVolume{ get; set; }

        public Cycle()
        {           
        }
       
        public Cycle(String cyclename, int cycleindex, double ufvolume)
        {
            CycleName = cyclename;
            CycleIndex = cycleindex;
            UFVolume = ufvolume;
        }
    }

}
